/*  $Id: zTableView.cc,v 1.3 1998/07/27 16:34:54 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#include "zOpenGL.h"

zOpenGL::zOpenGL(QWidget *parent) 
					: BaseComponent(parent,"OpenGL")
{
	look = new QGLWidget(this,"foo");
	resize(200,110);
	setLook(look);
}

void 
zOpenGL::fillAttributes()
{
	genericFillAttrib();

}

void 
zOpenGL::interpretAttributes()
{
	genericInterpAttrib();

	QString i;

}

void
zOpenGL::writeInits()
{
	if(global->queryHeader().find("qgl.h") == -1)
		addHead("#include <qgl.h>");
	
	QString i;

        i.sprintf("setCaption(\"%s\");\n",caption());
        WRITEATTRIB("Caption",i);

	if(!iconPix->isEmpty())
	{
		i.sprintf("setIcon(*new QPixmap(\"%s\"));\n",iconPix->data());
		WRITEATTRIB("Pixmap",i);
	}

       if(isWritten("Maximum Width") || isWritten("Maximum Height"))
       {
	   i.sprintf("setMaximumSize(%d,%d);\n",
		     look->maximumSize().width(),look->maximumSize().height());
	   writeInParent(i);
       }
       if(isWritten("Minimum Width") || isWritten("Minimum Height"))
       {
	   i.sprintf("setMinimumSize(%d,%d);\n",
		     look->minimumSize().width(),look->minimumSize().height());
	   writeInParent(i);
       }

        if(!tooltipData->isEmpty())
        {
                QString p;
                if(noFuncs() == TRUE)
                        p = name();
                else
                        p = "this";

                i.sprintf(
                "QToolTip::add(%s,\"%s\");\n"
                        ,p.data(),tooltipData->data());
                writeLine(i);
        }

        i.sprintf(
        "setGeometry(%d,%d,%d,%d);\n"
                ,x(),y(),width(),height());
        writeInParent(i);

        if(*uiStyle == "Motif")
               i.sprintf("setStyle(MotifStyle);\n");
        else if(*uiStyle == "Default")
                i = "";
        else if(*uiStyle == "Windows")
                i.sprintf("setStyle(WindowsStyle);\n");
        if(!i.isEmpty()) writeInParent(i);
}

void
zOpenGL::fillMembInfo()
{
        //fills generic virtual protected stuffs
        genericFillMembInfo();

	addMember("void initializeGL()","","");
	addMember("void resizeGL(int width, int height)","","");
	addMember("void paintGL()","","");
        
	//empty destructor
        addMember("destructor()","","",0,2,1);

        //very generic constructor
        addMember("constructor(QWidget *parent=0, char *name=0)",
                        "init(parent,name)","",0,2,1);

}

/******************************************************************************
 Uncomment if you intend to link this in dynamically, otherwise not necesary
******************************************************************************/
extern "C"
{
        zOpenGL *yourself(QWidget *parent)
        {
                return (new zOpenGL(parent));
        }
}
