/*  $Id: zTableView.h,v 1.3 1998/07/27 16:34:54 zachsman Exp $
 *
 *   PART OF QtEZ BY SAM MAGNUSON (http://qtez.zax.net/qtez/):
 *   QtEZ is bound by the licensing agreement of Troll Tech AS
 *      free software edition
 */

#ifndef OPENGL_H
#define OPENGL_H

#include "../../src/components/BaseComp.h"
#include "../../src/main.h"
#include <qgl.h>

class
zOpenGL : public BaseComponent
{
   private:
	QGLWidget *look;
   public:
	
	//Constructor
	zOpenGL(QWidget *parent);
	
	//Attribute Information passing
	virtual void fillAttributes();
        virtual void interpretAttributes();
	
	//Write your intialization routine for source dumping
	virtual void writeInits();

	//Fill in your initial members + member info
	virtual void fillMembInfo();

	virtual int canHaveChildren() { return 1; }

	//Of what type are you?
	virtual char *queryQType() { return "QGLWidget"; }


/******************************************************************************
		SPECIAL PURPOSE QUERIES, RARELY NECESARY
******************************************************************************/
        //Should be instantiated?
        virtual int instantiate() { return 1; }

        //Constructor overload (for instantiating in parent)
        //Returning 0 is the same as returning "(this,name)"
//        virtual char *specialInit() { return 0; }

	//This will be the string used in the class definition, only use
	//if your component inherits something different the queryQType() 
	//returns.
        virtual char *specialInher() { return 0; }

	//Use this only if you want this widget not to be cut/copyable, mostly
	//because it has more interworkings, or you don't want multiple ones
	//etc..
	virtual int copyAble() { return 1; }
	// About Screen
	virtual char* aboutComp() { 
	    static QString s;
	    s.sprintf ("QGLWidget Component %s\ncreated by Christian Ordig\nemail: %s",VERSION,EMAIL);
//	    printf ("%s",(char*)s.data());
	    return (const char*) s;}
};

/******************************************************************************
 Uncomment if you intend to link this in dynamically, otherwise not necesary
******************************************************************************/
extern "C"
{
        zOpenGL *yourself(QWidget *parent);
}
#endif
